
#ifndef KEYPAD_H

	#define KEYPAD_H 1

	#define KEYPAD_PORT PORTD
	#define KEYPAD_PINS PIND
	#define KEYPAD_PIN_MASK 0x0F
	#define KEYPAD_DDR DDRD

	#define KP_ROW1_PIN 0
	#define KP_ROW2_PIN 1
	#define KP_ROW3_PIN 2
	#define KP_ROW4_PIN 3

	#define KP_COL1_PIN 4
	#define KP_COL2_PIN 5
	#define KP_COL3_PIN 6

	#define DIGIT1_PORT PORTF
	#define DIGIT1_PINS PINF
	#define DIGIT1_DDR DDRF

	#define DIGIT2_PORT PORTC
	#define DIGIT2_PINS PINC
	#define DIGIT2_DDR DDRC

	#define DIGIT_LL_PIN 0
	#define DIGIT_BOT_PIN 1
	#define DIGIT_LR_PIN 2
	#define DIGIT_DP_PIN 3
	#define DIGIT_MID_PIN 4
	#define DIGIT_UL_PIN 5
	#define DIGIT_TOP_PIN 6
	#define DIGIT_UR_PIN 7

	#define DIGIT_0 0b00011000
	#define DIGIT_1 0b01111011
	#define DIGIT_2 0b00101100
	#define DIGIT_3 0b00101001
	#define DIGIT_4 0b01001011
	#define DIGIT_5 0b10001001
	#define DIGIT_6 0b10001000
	#define DIGIT_7 0b00011011
	#define DIGIT_8 0b00001000
	#define DIGIT_9 0b00001011
	#define DIGIT_A 0b00001010
	#define DIGIT_B 0b11001000
	#define DIGIT_C 0b10011100
	#define DIGIT_D 0b01101000
	#define DIGIT_E 0b10001100
	#define DIGIT_F 0b10001110

	#define ENCODER_PORT PORTB
	#define ENCODER_PINS PINB
	#define ENCODER_DDR DDRB
	#define ENCODER_LEFT_PIN 0
	#define ENCODER_RIGHT_PIN 1
	#define ENCODER_MASK (_BV(ENCODER_RIGHT_PIN) | _BV(ENCODER_LEFT_PIN))

	uint8_t DIGIT_VALUES[] = {DIGIT_0, DIGIT_1, DIGIT_2, DIGIT_3, DIGIT_4, DIGIT_5,
		DIGIT_6, DIGIT_7, DIGIT_8, DIGIT_9, DIGIT_A, DIGIT_B, DIGIT_C, DIGIT_D, DIGIT_E, DIGIT_F};

	uint8_t ENCODER_SEQUENCE[] = {0, 1, 3, 2};

	//pull-up-disable pin
	#define PUD 4 /* why isn't this defined in the avr stuff?? */

	void init_timer0(void);

	void init_display(void);

	void init_keypad(void);
	void scan_keypad(void);
	void send_keypad_data(void);

	void init_encoder(void);
	void scan_encoder(void);

	void compute_encoder_value(void);
	void display_encoder_value(void);
	void send_encoder_data(void);

	/* Tasks */
	TASK(USB_MIDI_Task);

	/* Event Handlers: */
	HANDLES_EVENT(USB_Connect);
	HANDLES_EVENT(USB_Disconnect);
	HANDLES_EVENT(USB_ConfigurationChanged);

	/* Scheduler Task List */
	TASK_LIST {
		{ .Task = USB_USBTask     , .TaskStatus = TASK_STOP },	//where does this come from?
		{ .Task = USB_MIDI_Task   , .TaskStatus = TASK_STOP },
	};

#endif
