#ifndef MIDI_H
#define MIDI_H 1

/* WARNING: MIDI channel is usually one-based, but we use zero-based here for sanity */
#define MIDI_CHANNEL 0
#define MIDI_COMMAND_NOTE_ON (0x90 | (0x0F & MIDI_CHANNEL))
#define MIDI_COMMAND_NOTE_OFF (0x80 | (0x0F & MIDI_CHANNEL))

#define MIDI_CONTROLLER 1
#define MIDI_COMMAND_CC	(0xB0 | (0x0F & MIDI_CHANNEL))

//Standard velocity
#define MIDI_STANDARD_VELOCITY 64

void SendMIDINoteChange(const uint8_t Pitch, const bool OnOff, const uint8_t CableID, const uint8_t Channel);
void SendMIDICC(const uint8_t controlllerNum, const uint8_t value, const uint8_t CableID, const uint8_t Channel);

#endif
